#include "KodListFunc.h"

// RXgN^
KODlistData::KODlistData()
{
	num	 = 0;
	head = NULL;
	end  = NULL;
	sentinel = NULL;
}

// Xgւ̓o^𓾂
int KODlistData::getNum()
{
	return num;
}

// Vȃf[^XgŌɓo^
// Ԓl̓f[^ꂽ̃AhX
Data *KODlistData::add(void *idata)
{
	if(idata == NULL) return NULL;

	Data *newdata = new Data(idata);
	if(newdata == NULL)	return NULL;

	if(head == NULL){
		head = newdata;
		head->next = NULL;
		head->before = NULL;
		end = head;
	}
	else{
		curr = end;
		curr->next = newdata;
		end = curr->next;
		end->next = NULL;
		end->before = curr;
	}
	num++;

	return newdata;			
}

// Vȃf[^w肵f[^̌ɉ	
// @@tag:wf[^    insFf[^
// tagNULLw肵ꍇ͐擪ɉ
// Ԓl̓f[^ꂽ̃AhX
Data *KODlistData::addData(Data *tag,void *ins)
{
	if(ins == NULL) return NULL;
		
	Data *nd = new Data(ins);
	if(nd == NULL)	return NULL;

	if(tag == NULL){
		nd->next = head;
		head->before = nd;
		head = nd;
	}
	else{
		nd->before = tag;
		nd->next = tag->next;
		tag->next = nd;
		tag->next->before = nd;
		if(nd->next == NULL) end = nd;
	}

	num++;

	return nd;
}

// Vȃf[^nԂ̃f[^̌ɉ	
// @@n:nԂ̃f[^    insFf[^
// Ԓl̓f[^ꂽ̃AhX
Data *KODlistData::addData(int n,void *ins)
{
	if(n >= num) return NULL;
	if(ins == NULL) return NULL;

	if(n < int(num/2)){
		curr = head;
		for(int i=0;i<n;i++){
			curr = curr->next;
		}
	}
	else{
		curr = end;
		for(int i=num-1;i>n;i--){
			curr = curr->before;
		}
	}

	return (addData(curr,ins));
}

// w肵f[^Aw肵f[^B̌ɕύX
// BNULL̏ꍇ͐擪ɑ}
int KODlistData::insData(Data *A,Data *B)
{
	if(A == NULL) return KOD_ERR;

	//snipData(A);
	//fprintf(stderr,"Out:%p-%p-%p\n",A->before,A,A->next);

	
	if(B == NULL){
		A->next = head;
		head->before = A;
		head = A;
		A->before = NULL;
	}
	else{
		A->before = B;
		A->next = B->next;
		if(B->next != NULL)
			B->next->before = A;
		B->next = A;
		if(A->next == NULL) end = A;
	}
	//fprintf(stderr,"In:%p-%p-%p\n",A->before,A,A->next);
	num++;

	return KOD_TRUE;
}


// nԂ̃f[^𓾂
void *KODlistData::getData(int n)
{
	if(n >= num) return NULL;
	if(n == 0)	return head->data;
	if(n == num-1) return end->data;

	if(n < int(num/2)){
		curr = head;
		for(int i=0;i<n;i++){
			curr = curr->next;
		}
	}
	else{
		curr = end;
		for(int i=num-1;i>n;i--){
			curr = curr->before;
		}
	}
	return curr->data;
}

// g̏
int KODlistData::clear()
{
	if(head == NULL)	return KOD_FALSE;	// ȂFALSE^[

	curr = old = head;
	while(curr != NULL){
		curr = old->next;
		delete old;
		old = curr;
	}
	head = NULL;
	end = NULL;
	num = 0;

	return KOD_TRUE;
}

// nԂ̃f[^Xg
int KODlistData::delData(int n)
{
	if(n >= num) return KOD_ERR;

	if(head->next == NULL){
		delete head;
		head = NULL;
		num=0;
		return KOD_TRUE;
	}

	curr = head;
	if(n==0){
		head = head->next;
		head->before = NULL;
	}
	else{
		for(int i=0;i<n;i++){
			old = curr;
			curr = curr->next;
		}
		old->next = curr->next;
		if(curr != end)
			curr->next->before = old;
		else
			end = old;
	}
	delete curr;
	num--;

	return KOD_TRUE;
}

// w肵f[^Xg
int KODlistData::delData(Data *d)
{
	if(d == NULL)	return KOD_ERR;

	if(head->next == NULL){
		delete head;
		head = NULL;
	}
	else if(d->before == NULL){
		curr = d->next;
		curr->before = NULL;
		head = curr;
	}
	else{
		curr = d->before;
		curr->next = d->next;
		if(d->next != NULL){
			curr = d->next;
			curr->before = d->before;
		}
		else
			end = curr;
	}

	delete d;
	num--;

	return KOD_TRUE;
}

// w肵f[^Xg͂
// ӁF͂Ȃ̂ŁA͂ꂽf[^͎ŏ邱
Data *KODlistData::snipData(Data *d)
{
	if(d == NULL)	return NULL;

	if(d->before == NULL){
		curr = d->next;
		curr->before = NULL;
		head = curr;
	}
	else{
		curr = d->before;
		curr->next = d->next;
		if(d->next != NULL){
			curr = d->next;
			curr->before = d->before;
		}
		else
			end = curr;
	}
	d->before = NULL;
	d->next = NULL;

	num--;

	return d;
}


// Xg̓ύX
void KODlistData::ChangeHead(Data *d)
{
	head = d;
}

// Xg̖ύX
void KODlistData::ChangeEnd(Data *d)
{
	end = d;
}


// nԂDataNXւ̃|C^𓾂(f[^ԍ0X^[gj
Data *KODlistData::getpData(int n)
{
	if(n >= num) return NULL;

	if(n < int(num/2)){
		curr = head;
		for(int i=0;i<n;i++){
			curr = curr->next;
		}
	}
	else{
		curr = end;
		for(int i=num-1;i>n;i--){
			curr = curr->before;
		}
	}

	return curr;
}

// w肵Data̎Dataւ̃|C^𓾂
Data *KODlistData::getNextpData(Data *data)
{
	return data->next;
}

// w肵Data̎Dataւ̃|C^𓾂
Data *KODlistData::getPrevpData(Data *data)
{
	return data->before;
}

// ŌDataIuWFNgւ̃|C^𓾂
Data *KODlistData::getEndpData()
{
	return end;
}


// w肵f[^Ɋ𗧂Ă
// Ԓl͊𗧂Ăf[^̃AhX
void *KODlistData::setSentinel(int n)
{
	if(n >= num) return NULL;

	sentinel = head;
	for(int i=0;i<n;i++){
		sentinel = sentinel->next;
	}

	return sentinel->data;
}

// nԖڌorÕf[^𓾂
// dn}CiX̏ꍇ͌̒T
void *KODlistData::getDataFromSentinel(int dn)
{
	if(sentinel == NULL)		// ݒ肳ĂȂNULLԂ
		return NULL;

	bool flag;
	if(dn < 0){
		flag = false;
		dn *= -1;
	}
	else{
		flag = true;
	}

	// O
	if(flag == true){
		curr = sentinel;
		for(int i=0;i<dn;i++){
			curr = curr->next;
			if(curr == NULL){		// f[^I[֗Ă܂
				return NULL;		// NULLԂ
			}
		}
		return curr->data;
	}
	// 
	else if(flag == false){
		curr = sentinel;
		for(int i=0;i<dn;i++){
			curr = curr->before;	
			if(curr == NULL){		// f[^擪֗Ă܂
				return NULL;		// NULLԂ
			}
		}
		return curr->data;
	}

	return NULL;
}

// ݂̈ʒunԖڌorOɈړ
void *KODlistData::shiftSentinel(int dn)
{
	if(sentinel == NULL)		// ݒ肳ĂȂNULLԂ
		return NULL;

	bool flag;
	if(dn < 0){
		flag = false;
		dn *= -1;
	}
	else{
		flag = true;
	}

	// O
	if(flag == true){
		for(int i=0;i<dn;i++){
			sentinel = sentinel->next;
			if(sentinel == NULL) return NULL;
		}
		return sentinel->data;
	}
	// 
	else if(flag == false){
		for(int i=0;i<dn;i++){
			sentinel = sentinel->before;
			if(sentinel == NULL) return NULL;
		}
		return sentinel->data;
	}

	return NULL;
}

// ̂ꏊ̃f[^擾
void *KODlistData::getSentinelData()
{
	if(sentinel == NULL)		// ݒ肳ĂȂNULLԂ
		return NULL;

	return sentinel->data;
}

// ̂f[^̎̃f[^擾
void *KODlistData::getNextSentData()
{
	if(sentinel == NULL)		// ݒ肳ĂȂNULLԂ
		return NULL;

	return sentinel->next->data;
}
