#include "NURBS_Func.h"
#include "SFQuant.h"

// RXgN^
SFQuant::SFQuant()
{
	U = V = 0;
	n = InitCoord();
	E = F = G = 0;
	L = M = N = 0;
}

// RXgN^({ʂ𓾂)
SFQuant::SFQuant(NURBSS *S,double u,double v)
{
	NURBS_Func nf;
	U = u;
	V = v;
	Coord du = nf.CalcDiffuNurbsS(S,u,v);			// u1K
	Coord dv = nf.CalcDiffvNurbsS(S,u,v);			// v1K
	Coord duu = nf.CalcDiffNNurbsS(S,2,0,u,v);		// u2K
	Coord dvv = nf.CalcDiffNNurbsS(S,0,2,u,v);		// v2K
	Coord duv = nf.CalcDiffNNurbsS(S,1,1,u,v);		// u,ve1K
	n = nf.CalcNormVecOnNurbsS(S,u,v);				// @xNg
	E = CalcInnerProduct(du,du);				// 1{
	F = CalcInnerProduct(du,dv);				// 1{
	G = CalcInnerProduct(dv,dv);				// 1{
	L = CalcInnerProduct(duu,n);				// 2{
	M = CalcInnerProduct(duv,n);				// 2{
	N = CalcInnerProduct(dvv,n);				// 2{

}

// {ʂ𓾂
int SFQuant::SetSFQ(NURBSS *S,double u,double v)
{	
	NURBS_Func nf;
	U = u;
	V = v;
	Coord du = nf.CalcDiffuNurbsS(S,u,v);			// u1K
	Coord dv = nf.CalcDiffvNurbsS(S,u,v);			// v1K
	Coord duu = nf.CalcDiffNNurbsS(S,2,0,u,v);		// u2K
	Coord dvv = nf.CalcDiffNNurbsS(S,0,2,u,v);		// v2K
	Coord duv = nf.CalcDiffNNurbsS(S,1,1,u,v);		// u,ve1K
	n = nf.CalcNormVecOnNurbsS(S,u,v);				// @xNg
	E = CalcInnerProduct(du,du);				// 1{
	F = CalcInnerProduct(du,dv);				// 1{
	G = CalcInnerProduct(dv,dv);				// 1{
	L = CalcInnerProduct(duu,n);				// 2{
	M = CalcInnerProduct(duv,n);				// 2{
	N = CalcInnerProduct(dvv,n);				// 2{

	return KOD_TRUE;
}