#include "MESH.h"

//////////////////////////////////////MESH class////////////////////////////////////////////////////////////////////////

// RXgN^
MESH::MESH()
{
	VertNum = EdgeNum = FaceNum = 0;
}

// bV̑SNA
int MESH::clear()
{
	int fnum = Face.getNum();
	int vnum = Vert.getNum();
	int ednum = Edge.getNum();

	for(int i=0;i<fnum;i++){
		HEface *f = (HEface *)Face.getData(i);
		delete f;
	}

	for(int i=0;i<vnum;i++){
		HEvert *v = (HEvert *)Vert.getData(i);
		v->DelQEM();
		delete v;
	}
	
	for(int i=0;i<ednum;i++){
		HEedge *e = (HEedge *)Edge.getData(i);
		delete e;
	}

	Face.clear();
	Vert.clear();
	Edge.clear();

	VertNum = EdgeNum = FaceNum = 0;

	return KOD_TRUE;
}

// w肵_
void MESH::DelVert(HEvert *v)
{
	Vert.delData(v->mom);	// XgO
	//fprintf(stderr,"del v:%p\n",v->mom);		// debug
	v->DelQEM();
	VertNum--;
	delete v;				// g̏
}
// w肵n[tGbW
void MESH::DelEdge(HEedge *e)
{
	Edge.delData(e->mom);	// XgO
	// fprintf(stderr,"del e:%p\n",e->mom);		// debug
	EdgeNum--;
	delete e;				// g̏
}

// w肵ʂ
void MESH::DelFace(HEface *f)
{
	Face.delData(f->mom);	// XgO
	//fprintf(stderr,"del f:%p\n",f->mom);		// debug
	FaceNum--;
	delete f;				// g̏
}

// w肵CfbNXƓCfbNX_To
HEvert *MESH::getIndexedVert(int index)
{
	int n = Vert.getNum();

	for(int i=0;i<n;i++){
		HEvert *v = (HEvert *)Vert.getData(i);
		if(v->index == index){
			return v;
		}
	}

	return NULL;
}

// w肵CfbNXƓCfbNXGbWTo
HEedge *MESH::getIndexedEdge(int index)
{
	int n = Edge.getNum();

	for(int i=0;i<n;i++){
		HEedge *e = (HEedge *)Edge.getData(i);
		if(e->index == index){
			return e;
		}
	}

	return NULL;
}

// w肵CfbNXƓCfbNXʂTo
HEface *MESH::getIndexedFace(int index)
{
	int n = Face.getNum();

	for(int i=0;i<n;i++){
		HEface *f = (HEface *)Face.getData(i);
		if(f->index == index){
			return f;
		}
	}

	return NULL;
}

// w肵CfbNX̃GbWf[^Ɋ𗧂Ă
HEedge *MESH::setSentinelOnIndexedEdge(int index)
{
	int n = Edge.getNum();	// GbWXg̑𓾂

	// w肵indexƓCfbNXf[^T
	for(int i=0;i<n;i++){
		HEedge *e = (HEedge *)Edge.getData(i);	// f[^擾
		if(e->index == index){
			Edge.setSentinel(i);				// ΁AɊ𗧂Ă
			return e;							// ̃f[^Ԃ
		}
	}

	return NULL;
}

// dnԖڌorÕGbWf[^𓾂
// n}CiX̏ꍇ͌̒T
HEedge *MESH::getIndexedEdgeFromSentinel(int dn)
{
	return (HEedge *)Edge.getDataFromSentinel(dn);
}

// w肵f̖@xNg߁Af->normɃZbg
int MESH::CalcFaceNorm(HEface *f)
{
	Coord a[MAXVERTNUMINFACE];

	HEedge *e = f->GetStartHE();
	for(int j=0;j<f->GetVetexNum();j++){	// ʂ\_̍Wl擾
		a[j] = e->GetStartVcoord();
		e = e->GetNextHE();
	}
	if(f->GetVetexNum() == TRIMESHVERTNUM){						// OpbV̏ꍇ
		f->SetNormVec(CalcNormVecFrom3Pts(a[0],a[1],a[2]));		// 3_@xNgvZAf->normɃZbg
		return KOD_TRUE;
	}
	else{									// OpbVȊȌꍇFALSE
		f->SetNormVec(SetCoord(0,0,0));
		return KOD_FALSE;
	}
}

// w肵f̖ʐς߁Af->areaɃZbg
int MESH::CalcFaceArea(HEface *f)
{
	Coord a[MAXVERTNUMINFACE];

	HEedge *e = f->GetStartHE();
	for(int j=0;j<f->GetVetexNum();j++){	// ʂ\_̍Wl擾
		a[j] = e->GetStartVcoord();
		e = e->GetNextHE();
	}
	if(f->GetVetexNum() == TRIMESHVERTNUM){
		f->SetFaceArea(CalcEuclid((a[1]-a[0])&&(a[2]-a[0]))/2);		// OpbV̖ʐςvZAf->areaɃZbg
		return KOD_TRUE;
	}
	else{
		f->SetFaceArea(0);		// OpbVȊO͔ΉƂ
		return KOD_FALSE;
	}
}

//	\[gꂽEdgeXgɁAύXꂽQEMRXgHEedge}
void MESH::InsertQEMD(HEedge *ins)
{
	Data *d;
	HEedge *e;
	int i=0;

	Edge.snipData(ins->mom);		// ԂύXf[^insXg甲o

	e = (HEedge *)Edge.getData(Edge.getNum()-1);


	d = Edge.getpData(0);
	for(int i=0;i<Edge.getNum();i++){
		e = (HEedge *)d->GetData();
		if(e->GetQEMD() > ins->GetQEMD()){		// Xg̒ڒ̃f[^QEMDinsQEMD傫ȂÃf[^̑Oins}
			if(!i){
				//fprintf(stderr,"a:%d-%d %p(%lf)-%p(%lf)\n",Edge.getNum(),i,e->mom,e->GetQEMD(),ins->mom,ins->GetQEMD());		// debug
				Edge.insData(ins->mom,NULL);
			}
			else{
				//fprintf(stderr,"b:%d-%d %p(%lf)-%p(%lf)\n",Edge.getNum(),i,e->mom,e->GetQEMD(),ins->mom,ins->GetQEMD());	// debug
				e = (HEedge *)((Edge.getPrevpData(d))->GetData());
				Edge.insData(ins->mom,e->mom);
			}
			//fprintf(stderr,"The edge is inserted before No.%d Edge\n",i);
			return;
		}
		d = Edge.getNextpData(d);
	}

	//fprintf(stderr,"The edge is inserted before No.%d Edge (END)\n",Edge.getNum()-1);
	d = Edge.getEndpData();
	e = (HEedge *)d->GetData();
	//fprintf(stderr,"c: %p,%p(%lf)-%p(%lf)\n",d,e->mom,e->GetQEMD(),ins->mom,ins->GetQEMD());
	Edge.insData(ins->mom,d);

}

// EdgeQEMRXg(Edge.qemD)ŏ\[g
void MESH::EdgeSortbyQEMD()
{
	Data *d;

	d = MergeSortForQEMD(Edge.getpData(0));	// QEMDEdge\[g
	Edge.ChangeHead(d);						// Xg̐擪Ȃ

	while(d->GetNextpData() != NULL)		// Xg̖T
		d = d->GetNextpData();
	Edge.ChangeEnd(d);						// Xg̖Ȃ

	// debug
	//fprintf(stderr,"////Edge List////\n");
	//HEedge *e;
	//Edge.setSentinel(0);
	//while((e = (HEedge *)Edge.getSentinelData()) != NULL){
	//	fprintf(stderr,"%p(%lf)\n",e->mom,e->GetQEMD());
	//	Edge.shiftSentinel(1);
	//}
	//fprintf(stderr,"\n");
}

// EdgeQEMRXg(Edge.qemD)ŏ\[gSub1
// http://www.geocities.jp/ky_webid/algorithm/021.html p
Data *MESH::MergeSortForQEMD(Data *x)
{
	Data *a, *b, *y;

	if(x == NULL || x->GetNextpData() == NULL)
		return x;

	a = x;
	b = x->GetNextpData();
	if(b != NULL)
		b = b->GetNextpData();

	while(b != NULL){
		a = a->GetNextpData();
		b = b->GetNextpData();
		if(b != NULL)
			b = b->GetNextpData();
	}

	y = a->GetNextpData();
	a->SetNextpData(NULL);

	return MergeListForQEMD(MergeSortForQEMD(x),MergeSortForQEMD(y));
}

// EdgeQEMRXg(Edge.qemD)ŏ\[gSub2
Data *MESH::MergeListForQEMD(Data *x,Data *y)
{
	Data z,*p;

	p = &z;

	while(x != NULL && y != NULL){
		if(((HEedge *)x->GetData())->qemD <= ((HEedge *)y->GetData())->qemD){
			p->SetNextpData(x);
			x->SetBeforepData(p);
			p = x;
			x = x->GetNextpData();
		}
		else{
			p->SetNextpData(y);
			y->SetBeforepData(p);
			p = y;
			y = y->GetNextpData();
		}
	}

	if(x == NULL){
		p->SetNextpData(y);
		y->SetBeforepData(p);
	}
	else{
		p->SetNextpData(x);
		x->SetBeforepData(p);
	}

	(z.GetNextpData())->SetBeforepData(NULL);

	return z.GetNextpData();
}

//////////////////////////////////////MESH class////////////////////////////////////////////////////////////////////////


////////////////////////////////////HEvert class////////////////////////////////////////////////////////////////////////

// qemQ[][]̏
void HEvert::NewQEM()
{
	qemQ = NewMatrix(QUADINDEX,QUADINDEX);
	for(int i=0;i<QUADINDEX;i++){
		for(int j=0;j<QUADINDEX;j++){
			qemQ[i][j] = 0;
		}
	}
}

// qemQ̃
void HEvert::DelQEM()
{
	if(qemQ != NULL)
		FreeMatrix(qemQ,QUADINDEX);
}

// qemQ̏
void HEvert::InitQEM()
{
	for(int i=0;i<QUADINDEX;i++){
		for(int j=0;j<QUADINDEX;j++){
			qemQ[i][j] = 0;
		}
	}
}

// qemp[^Zbg
int HEvert::SetQEM(Matrix buf)
{

	if(qemQ == NULL) return KOD_ERR;

	for(int i=0;i<QUADINDEX;i++){
		for(int j=0;j<QUADINDEX;j++){
			qemQ[i][j] = buf[i][j];
		}
	}

	return KOD_TRUE;
}

// qemp[^
int HEvert::AddQEM(Matrix buf)
{
	if(qemQ == NULL) return KOD_ERR;

	for(int i=0;i<QUADINDEX;i++){
		for(int j=0;j<QUADINDEX;j++){
			qemQ[i][j] += buf[i][j];
		}
	}

	return KOD_TRUE;
}

// qemp[^𓾂
Matrix HEvert::GetQEM()
{
	return qemQ;
}

////////////////////////////////////HEvert class////////////////////////////////////////////////////////////////////////



////////////////////////////////////HEedge class////////////////////////////////////////////////////////////////////////

// ̃n[tGbW(Lʂɂ)1Õn[tGbWԂ
HEedge *HEedge::GetPrevHE()
{
	int n = this->face->GetVetexNum();

	HEedge *e,*e_;
	
	e_ = this;

	for(int i=0;i<n-1;i++){
		e = e_->ne;
		e_ = e;
	}

	return e;
}

////////////////////////////////////HEedge class////////////////////////////////////////////////////////////////////////
