#ifndef _NURBS_FUNC_H_
#define _NURBS_FUNC_H_

#include "BODY.h"
#include "Quaternion.h"
#include "SFQuant.h"

#define PTNUMMAX			10000			// NURBS̓_̍ő吔
#define RANKMAX				9				// NURBS̊K̍ől
#define INTERSECPTNUMMAX	1000			// _i[z
#define NEAREST_GAP			0.01			// 2__Ƃ݂Ȃ
#define CONVERG_GAP			1.0e-9			// j[g@̎𔻕ʂ臒l
#define CONVDIVNUM			100				// vZp̃p[^
#define TRM_BORDERDIVNUM	100				// gEɐ_̐
#define FORWARD				1				// ǐՂ̕()
#define INVERSE				-1				// ǐՂ̕(t)
#define PARAM_U				0				// u\V{
#define PARAM_V				1				// v\V{
#define OUTTER_TRIM			0				// Og~Ö
#define INNER_TRIM			1				// g~Ö
#define PARAMDIVNUM			10				// lTp̃p[^
#define RUNGE_KUTTA			0				// Runge-Kutta@̃V{
#define BULIRSH_STOER		1				// Bulirsch-Stoer@̃V{
#define CALC_OFFSET			2				// ItZbgȖʌvZ̃V{


// NURBS̑W߂NX`
class NURBS_Func
{
public:
	Coord CalcNurbsCCoord(NURBSC *,double);						// w肵mbgtłNURBSȐ̍Wl߂
	void CalcNurbsCCoords(NURBSC *,int,double *,Coord *);		// w肵mbgtQłNURBSȐ̍WlQ߂
	Coord CalcNurbsSCoord(NURBSS *,double,double);				// w肵mbgu,vłNURBSȖʂ̍W_߂
	void CalcNurbsSCoords(NURBSS *,int,Coord *,Coord *);		// w肵mbgu,vQłNURBSȖʂ̍WlQ߂
	int GenNurbsC(NURBSC *,int,int,int,double [],double [],Coord [],double [],int[],int);	// 1NURBSȐ𐶐
	int GenNurbsC(NURBSC *,NURBSC);								// 1NURBSȐ𐶐(NURBSȐ̃Rs[)(I[o[[h)
	int GenNurbsS(NURBSS *,int,int,int,int,double *,double *,double **,Coord **,double,double,double,double);	// 1NURBSȖʂ𐶐
	int GenNurbsS(NURBSS *,NURBSS);								// 1NURBSȖʂ𐶐(NURBSȖʂ̃Rs[)(I[o[[h)
	int GenRotNurbsS(NURBSS *,NURBSC,Coord,double);				// 1NURBSȐ鎲ɂpx]]T[tFX𐶐
	int GenSweepNurbsS(NURBSS *,NURBSC,Coord,double);			// 1NURBSȐ炠鎲ɂ鋗XC[vXC[vT[tFX𐶐
	int GenIsoparamCurveU(NURBSS *,double,NURBSC *);			// NURBSȖʏup[^lŒ肵Ƃ̃AC\pgbNNURBSȐ𐶐
	int GenIsoparamCurveV(NURBSS *,double,NURBSC *);			// NURBSȖʏvp[^lŒ肵Ƃ̃AC\pgbNNURBSȐ𐶐
	int GenTrimdNurbsS(TRIMD_NURBSS *,TRIMD_NURBSS);			// gʂ𐶐
	int DelTrimdNurbsS(TRIMD_NURBSS *);							// gʂ폜([)
	void DelNurbsC(NURBSC *);									// NURBSȐ폜
	void DelNurbsS(NURBSS *);									// NURBSȖʂ폜
	double CalcBSbasis(double,double [],int,int,int);			// BXvC֐vZAvZʂԂ
	double CalcDiffBSbasis(double,double [],int,int,int);		// BXvC֐1KW߂
	double CalcDiffBSbasisN(double,double [],int,int,int,int);	// BXvC֐NKW߂
	Coord CalcDiffNurbsC(NURBSC *,double);						// NURBSȐ1KW߂
	Coord CalcDiff2NurbsC(NURBSC *,double);						// NURBSȐ2KW߂
	Coord CalcDiffNNurbsC(NURBSC *,int,double);					// NURBSȐrKW߂
	Coord CalcDiffuNurbsS(NURBSS *,double,double);				// NURBSȖʂu1KW߂
	Coord CalcDiffvNurbsS(NURBSS *,double,double);				// NURBSȖʂv1KW߂
	Coord CalcDiffNNurbsS(NURBSS *,int,int,double,double);		// NURBSȖʂ̊eCӊKƂ̔W߂
	Coord CalcNormVecOnNurbsS(NURBSS *,double,double);			// NURBSȖʏ(u,v)ɂ@xNgƂ߂
	Coord CalcDiffuNormVecOnNurbsS(NURBSS *,double,double);		// NURBSȖʏ(u,v)ɂ@xNgu1KƂ߂
	Coord CalcDiffvNormVecOnNurbsS(NURBSS *,double,double);		// NURBSȖʏ(u,v)ɂ@xNgv1KƂ߂
	double CalcMeanCurvature(NURBSS *,double,double);			// NURBSȖʏ(u,v)ɂ镽ϋȗ߂
	double CalcMeanCurvature(SFQuant);							// I[o[[h
	Coord CalcMeanCurvatureNormVec(NURBSS *,double,double);		// NURBSȖʏ(u,v)ɂ镽ϋȗ@xNg߂
	double CalcGaussCurvature(NURBSS *,double,double);			// NURBSȖʏ(u,v)ɂKEXȗ߂
	double CalcGaussCurvature(SFQuant);							// I[o[[h
	Coord CalcGaussCurvatureNormVec(NURBSS *,double,double);	// NURBSȖʏ(u,v)ɂKEXȗ@xNg߂
	int CalcuIntersecPtNurbsLine(NURBSS *,Coord,Coord,int,Coord *,int);	// NURBSȖʂƒ̌_Zo
	int CalcIntersecPtNurbsPt(NURBSS *,Coord,int,double,Coord *);		// NURBSȖʏɂԏ1_̍ŋߖT_߂(j[g@)
	int CalcIntersecCurve(NURBSC *,Coord,Coord,int,double *,int,int);	// NURBSȐƕʂƂ̌_߂(j[g@)
	int CalcIntersecIsparaCurveU(NURBSS *,double,Coord,Coord,int,double *,int);	// uAC\pȐƕʂƂ̌_߂(j[g@)
	int CalcIntersecIsparaCurveV(NURBSS *,double,Coord,Coord,int,double *,int); // vAC\pȐƕʂƂ̌_߂(j[g@)
	int CalcIntersecCurve3(NURBSC *,Coord,Coord,double *,int);	// 3ȉNURBSȐƕʂƂ̌_߂
	int CalcIntersecPtsPlaneV3(NURBSS *,Coord,Coord,int,Coord *,int);	// ṼAC\pȐw肵ŐCe3ȉ̋ȐNURBSȖʂƂ̌_㐔vZŎZo
	int CalcIntersecPtsPlaneU3(NURBSS *,Coord,Coord,int,Coord *,int);	// ṼAC\pȐw肵ŐCe3ȉ̋ȐNURBSȖʂƂ̌_㐔vZŎZo
	int CalcIntersecPtsPlaneV(NURBSS *,Coord,Coord,int,Coord *,int);	// ṼAC\pȐw肵ŐCeȐNURBSȖʂƂ̌_Zo
	int CalcIntersecPtsPlaneU(NURBSS *,Coord,Coord,int,Coord *,int);	// ŨAC\pȐw肵ŐCeȐNURBSȖʂƂ̌_Zo
	int CalcIntersecPtsPlaneSearch(NURBSS *,Coord,Coord,double,int,Coord *,int,int);	// NURBSȖʂƕʂƂ̌_QǐՖ@ŋ߂
	int CalcIntersecPtsOffsetPlaneSearch(NURBSS *,double,Coord,Coord,double,int,Coord *,int,int);// ItZbgNURBSȖʂƕʂƂ̌_QǐՖ@ŋ߂
	int CalcIntersecPtsNurbsSNurbsC(NURBSS *,NURBSC *,int,Coord *,int);	// NURBSȖʂNURBSȐƂ̌_߂(j[g@)
	int CalcIntersecPtsNurbsSGeom(NURBSS *,NURBSS *,int,int,Coord *,Coord *,int);		// NURBSȖʓm̌̓_􉽊wIɂ߂
	int CalcIntersecPtsNurbsSSearch(NURBSS *,NURBSS *,int,double,Coord *,Coord *,int);	// NURBSȖʓm̌(_Q)ǐՖ@ŋ߂
	int CalcIntersecPtsNurbsCNurbsCParam(NURBSC *,NURBSC *,int,Coord *,int);	// 2DpgbNNURBSȐm̌_߂
	int GetBSplCoef3(int,int,int,double *,double **);			// 3BXvCȐ̊eW߂@(at^3 + bt^2 + ct + ďWa,b,c,dԂ)
	int GetBSplCoef2(int,int,int,double *,double **);			// 2BXvCȐ̊eW߂@(at^2 + bt + čWa,b,cԂ)
	int GetBSplCoef1(int,int,int,double *,double **);			// 1BXvCȐ̊eW߂@(at + b̌Wa,bԂ)
	void ShiftNurbsS(NURBSS *,Coord);							// NURBSȖʂ̃Vtg
	void ShiftNurbsC(NURBSC *,Coord);							// NURBSȐ̃Vtg
	void ChRatioNurbsS(NURBSS *,Coord);							// NURBSȖʂ̔{ύX
	void ChRatioNurbsC(NURBSC *,Coord);							// NURBSȐ̔{ύX
	int SetCPNurbsS(NURBSS *,NURBSS);							// Rg[|Cg
	int GenInterpolatedNurbsC1(NURBSC *,Coord *,int,int);		// ^ꂽ_ԂnKNURBSȐ𐶐
	int GenInterpolatedNurbsC2(NURBSC *,Coord *,int,int);		// ^ꂽ_ԂnKNURBSȐ𐶐(Ȑ)
	int GenApproximationNurbsC(NURBSC *,Coord *,int,int);		// ^ꂽ_ߎnKNURBSȐ𐶐
	int GenNurbsCfromCP(NURBSC *,Coord *,int,int);				// Rg[|CgNURBSȐ𐶐
	int GenPolygonalLine(NURBSC *,Coord *,int);					// ܂𐶐
	int GenInterpolatedNurbsS1(NURBSS *,Coord **,int,int,int,int);	// ^ꂽ_ԂnKNURBSȖʂ𐶐
	int GenPolygonalSurface(NURBSS *,Coord **,int,int);				// ܂ʂ𐶐
	int GenApproximationNurbsS(NURBSS *,Coord **,int,int,int,int);	// ^ꂽ_ߎnKNURBSȖʂ𐶐
	int GenNurbsSfromCP(NURBSS *,Coord **,int,int,int,int);			// ^ꂽRg[|CgnKNURBSȖʂ𐶐
	int DetermPtOnTRMSurf(TRMS *,double,double);					// ڒNURBSȖʏ1_(u,v)g~Öɂ̂𔻒肷
	void RotNurbsS(NURBSS *,Coord,double);							// NURBSȖʂ]
	void RotNurbsC(NURBSC *,Coord,double);							// NURBSȐ]
	int DetectInterfereNurbsS(NURBSS *,NURBSS *,int);				// NURBSȖ(g)m̊o
	int DetectInterfereTrmS(TRIMD_NURBSS *,TRIMD_NURBSS *,int);		// NURBSȖ(gL)m̊o
	int CalcIntersecPtsPlaneGeom(NURBSS *,Coord,Coord,int,int,Coord *,int);			// NURBSȖʂƕʂƂ̌_Q􉽊wIɋ߂
	double CalcNurbsCLength(NURBSC *);							// NURBSȐ̐߂
	double CalcNurbsCLength(NURBSC *,double,double);			// NURBSȐ̎wԂ̐߂
	int CalcDeltaPtsOnNurbsC(NURBSC *,double,Coord *);			// w肵ԊuNURBSȐ̍Wlo͂
	int CalcExtremumNurbsC(NURBSC *,Coord,double *,int);		// NURBSȐ̎w肵ɂɒl̍Wl𓾂
	void GetEqIntervalKont(int,int,Vector);						// Ȑ/Ȗʃp[^瓙ԊuȃmbgxNgZo
	void ChangeKnotVecRange(Vector,int,int,int,double,double);	// mbgxNg̃p[^`ύX

	int CalcExtSearchCurve(NURBSS *,Coord,Coord,double,NURBSC *,NURBSC *);			// ɒnT𓾂()
	int CalcExtGradCurve(NURBSS *,Coord,Coord,double,NURBSC *,NURBSC *);			// ɒnXΐ𓾂()
	int TrimNurbsSPlane(TRMS *,Coord,Coord);					// NURBSȖʂ𕽖ʂŃg()

	int New_NurbsC(NURBSC *,int,int);			// NURBSȐ̃[m
	void Free_NurbsC_1DArray(NURBSC *,int);		// NURBSȐz̃[
	void Free_NurbsC(NURBSC *);					// NURBSȐ̃[
	int New_NurbsS(NURBSS *,int [],int []);		// NURBSȖʂ̃[m
	void Free_NurbsS_1DArray(NURBSS *,int);		// NURBSȖʔz̃[
	void Free_NurbsS(NURBSS *);					// NURBSȖʂ̃[
	int New_TrmS(TRMS *,int);					// gʂ̃[m
	void Free_TrmS_1DArray(TRMS *,int);			// gʔz̃[
	void Free_TrmS(TRMS *);						// gʂ̃[
	int New_CompC(COMPC *,int);					// Ȑ̃[m
	void Free_CompC_1DArray(COMPC *,int);		// Ȑz̃[
	void Free_CompC(COMPC *);					// Ȑ̃[

	void DebugForNurbsC(NURBSC *);				// NURBSȐfobOvg
	void DebugForNurbsS(NURBSS *);				// NURBSȖʏfobOvg



private:
	int GetNurbsCCoef(NURBSC *,double **,int,Coord *,double *);	// NURBSȐ̌W߂(ō3)
	int CalcEquation(double *,double *,int);					// 3܂ł𔻕ʂĉ
	void GetNurbsSCoef(int,double **,double *,Coord *,int,Coord *,double *);	// NURBSȖʂɂu܂vŒ肵ꍇɓNURBSȐC(u) or C(v)̕ꕪq̌W߂
	void GetIntersecEquation(int,Coord *,double *,Coord,Coord,double *);		// NURBSȐƕʂ̌op3𓾂
	int SearchIntersectPt(NURBSS *,Coord,Coord,double,double *,double *,int);	// j[g@ɂ_(NURBSȖʂƕ)
	int SearchIntersectPt_RKM(NURBSS *,Coord,Coord,double,double *,double *,int);	// 4̃QNb^@ɂ_(NURBSȖʂƕ)
	int SearchIntersectPt_BS(NURBSS *,Coord,Coord,double,double *,double *,int);	// Bulirsch-Stoer@ɂ_(NURBSȖʂƕ)
	int SearchIntersectPt_OS(NURBSS *,Coord,Coord,double,double *,double *,int);	// 4̃QNb^@ɂ_(ItZbgNURBSȖʂƕ)	
	int GetSIPParam1(NURBSS *,double ,double ,Coord ,Coord ,int ,Coord *);		// NURBSȖʂƕʂ̌_\̉Eӂ̒l𓾂
	int SearchIntersectPt(NURBSS *,NURBSS *,double,double *,double *,double *,double *,int);		// j[g@ɂ_(NURBSȖʓm)
	int DetermPtOnTRMSurf_sub(CONPS *,double,double);				// gEȐ̏ꍇ̃g~ÖO
	void GetCurveKnotParam1(Coord *,int,Vector);					// eʉߓ_̋Ȑp[^Zo(R[h̔䂩Zo)
	void GetCurveKnotParam2(Coord *,int,Vector);					// eʉߓ_̋Ȑp[^Zo(R[h̔̕䂩Zo)
	void GetSurfaceKnotParam(Vector,Vector,Coord **,int,int);		// eʉߓ_̋Ȗʃp[^Zo
	void GetInterpolatedKnot(Vector,int,int,int,Vector);			// Ȑ/Ȗʃp[^ԗpmbgxNgZo
	void GetApproximatedKnot(Vector,int,int,int,Vector);			// Ȑ/Ȗʃp[^ߎpmbgxNgZo
	int SetApproximationCPnum(int);									// _񐔂琶Rg[|CgZ肷
	void CalcApproximationCP_LSM(Coord *,Vector,Vector,int,int,int,int,Coord *);	// ŏ2@ŋߎRg[|Cg߂
	int RemoveTheSamePoints(NURBSS *,Coord *,int);					// NURBSȖʏ̓_
	int CheckTheSamePoints(Coord *,int);							// _
	int CheckTheSamePoints(double *,int);							// _
	int CheckTheSamePoints2D(Coord *,int);							// 2Dʓ̓_
	double CalcDiffNurbsSDenom(NURBSS *,int,int,double,double);		// NURBSȖʕ̊eCӊKƂ̔W߂
	Coord CalcDiffNurbsSNumer(NURBSS *,int,int,double,double);		// NURBSȖʕq̊eCӊKƂ̔W߂
	Coord TrimNurbsSPlaneSub1(double,double,double,double,double,double); // TrimNurbsSPlanẽTu֐(2̌_Ƃ߂)
	int CalcIntersecPtsPlaneSearch_Sub(NURBSS *,double,double,Coord,Coord,Coord);	// ʂяo(u,v)Qlɖʂ̃GbW(new_u,new_v)𓾂
	Coord GetMinDistance(Coord,Coord *,int);						// ŏWlԂ
	int CheckClossedPoints(NURBSS *,Coord,Coord,Coord);				// w肵_2_ΊpƂ闧̂̒ɑ݂邩𒲂ׂ
	int GetMinDist(NURBSS *,Coord ,Coord *,int ,Coord *);			// ŏ𒲂ׂ
};


#endif
