/*********************************************************
* VRML1.0t@Cǂݍ݁An[tGbW\֊i[  *
* 2012/4 K.Takasugi                                      *
**********************************************************/

#include "VRML_Parser.h"

int VRML_PARSER::Vrml_Parser_Main(BODY *body, char fname[])
{
	FILE *fp;
	char mes[BUFSIZEMAX];		// o͗pbZ[Wi[obt@
	char buf[BUFSIZEMAX];		// ꎞi[pobt@
	int tag;					// ^Oʗp
	int flag;

	// VRMLt@CI[v
	if((fp = fopen(fname,"r")) == NULL){
		sprintf(mes,"KOD_ERROR: Cannot open %s",fname);
		SetMessage(mes);
		return(KOD_ERR);
	}

	// wb_ǂݍ
	fgets(buf,sizeof(buf),fp);
	if(strcmp(buf,"#VRML V1.0 ascii\n")){
		sprintf(mes,"KOD_ERROR: Kodatuno supports only #VRML V1.0 ascii.     Please check VRML file version.");
		SetMessage(mes);
		fclose(fp);
		return(KOD_ERR);
	}

	body->Mesh = new MESH;		// MESHNX̃[m

	// 1sǂݍ݂ȂA^O͂Ă
	while(fgets(buf,sizeof(buf),fp) != NULL){
		if((tag = CheckTags(buf)) == KOD_ERR){	// ^O
			continue;							// o^ꂽ^OĂȂs͓ǂݔ΂
		}

		if(tag == Coordinate3){					// OWp^O𔭌
			flag = GetCoords(fp,body->Mesh);	// OWlMESHɊi[
			if(flag == KOD_ERR){
				body->Mesh->clear();
				return KOD_ERR;
			}

		}
		else if(tag == IndexedFaceSet){			// t@Zbg`p^O𔭌
			flag = GetFacets(fp,body->Mesh);	// t@ZbgMESHɊi[
			if(flag == KOD_ERR){
				body->Mesh->clear();
				return KOD_ERR;
			}
		}
	}

	fclose(fp);

	// n[tGbWA_Aʂꂼ̑𓾂
	body->Mesh->EdgeNum = body->Mesh->Edge.getNum();
	body->Mesh->VertNum = body->Mesh->Vert.getNum();
	body->Mesh->FaceNum = body->Mesh->Face.getNum();

	GetHalfEdgePair(body->Mesh);	// ΂ƂȂtn[tGbWւ̃|C^𓾂

	SetFaceParam(body->Mesh);		// eʂɖʐςƒPʖ@xNg̏t

	body->MaxCoord = 10;			// {͂Ƃ肠10ɂĂ

	body->TypeNum[_MESH] = 1;		// TypeNum1

	return KOD_TRUE;
}

// eʂɖʐς̏t
void VRML_PARSER::SetFaceParam(MESH *mesh)
{
	for(int i=0;i<mesh->FaceNum;i++){
		HEface *f = (HEface *)mesh->Face.getData(i);
		mesh->CalcFaceArea(f);		// ʐς̏t
		mesh->CalcFaceNorm(f);		// Pʖ@xNg̏t
	}
}

// ΂ƂȂtn[tGbWւ̃|C^𓾂
int VRML_PARSER::GetHalfEdgePair(MESH *mesh)
{
	bool flag = false;

	// Sn[tGbWɑ΂
	for(int i=0;i<mesh->EdgeNum;i++){
		HEedge *e = (HEedge *)mesh->Edge.getData(i);	// iԂ̃n[tGbWo
		mesh->Edge.setSentinel(0);						// ŏ̃n[tGbWɗĂ
		flag = false;									// tOnee
		for(int j=0;j<mesh->EdgeNum;j++){				// iԂ̃n[tGbW̑΂T
			if(j==i){									// n[tGbWĂꍇ
				mesh->Edge.shiftSentinel(1);			// 1炷
				continue;
			}
			HEedge *e_ = (HEedge *)mesh->Edge.getSentinelData();	// ̗Ăn[tGbW̃f[^𓾂
			if(e_->ne->vert->index == e->vert->index &&				// jԂ̃n[tGbW̎̃n[tGbW̃CfbNXiԂ̃n[tGbW̃CfbNXƓ
				e_->vert->index == e->ne->vert->index){				// iԂ̃n[tGbW̎̃n[tGbW̃CfbNXjԂ̃n[tGbW̃CfbNXƓȂ
				e->pair = e_;										// ΂
				flag = true;							// tOnm
				break;									// ̃n[tGbWɈړ
			}
			mesh->Edge.shiftSentinel(1);				// ΂ĂȂꍇ́A1炷
		}
		if(flag == false){								// Ȃ(ʂ̋EGbW)
			e->pair = NULL;								// ΂NULL
		}
	}

	return KOD_TRUE;
}

// t@ZbgMESHɊi[
int VRML_PARSER::GetFacets(FILE *fp,MESH *mesh)
{
	char *p,*q;
	char buf[BUFSIZEMAX],word[BUFSIZEMAX];
	int index[MAXVERTNUMINFACE]={-1,-1,-1,-1};	// _̃CfbNXZbg
	int edgecount = 0;							// GbW̑

	// OWlSēǂݍނ܂1sÂǂݍ
	while(!feof(fp)){
		GetLine(fp,buf);						// 1s擾
		if(strstr(buf,"coordIndex") == NULL)	// "coordIndex"^OȂ
			continue;							// ܂œǂݑ

		//  "coordIndex"^OĂ璸_W擾
		while(GetLine(fp,buf)){							// 1s擾
			if(strchr(buf,']') != NULL) break;			// f[^Ig[N']'̍sǂݍݏI
			int i=0;
			p = strtok(buf,",");						// J}؂ŕ𒊏oĂ
			sscanf(p,"%d",&index[i]);					// o𐮐ɕϊ
			i++;
			while(p != NULL){
				if((p = strtok(NULL,",")) != NULL){
					sscanf(p,"%d",&index[i]);
					if(index[i] == -1){					// t@Zbg̏I-1
						edgecount += i;					// GbWCNg
						SetMesh(mesh,index,edgecount);	// ܂ł̃CfbNXZbgŃbV𐶐
						i = 0;							// CfbNXԍZbg
					}
					else i++;
				}
			}
		}

		return KOD_TRUE;	// ɓǂݍݏI
	}

	return KOD_ERR;			// OWl擾Ƀt@CI:G[
}

// _̃CfbNXZbgAbVf[^𐶐
void VRML_PARSER::SetMesh(MESH *mesh,int vindex[],int edgecount)
{
	int vcount=MAXVERTNUMINFACE;
	HEface *f;
	HEvert *v;

	// _F
	for(int i=0;i<MAXVERTNUMINFACE;i++){
		if(vindex[i] == -1)
			vcount = i;
	}

	int startnum = edgecount - vcount;

	// n[tGbWo^
	for(int i=0;i<vcount;i++){
		HEedge *e = new HEedge();		// n[tGbW1m
		v = (HEvert *)mesh->Vert.getData(vindex[i]);
		e->SetVert(v);					// ɓo^Ă_Xg瓯CfbNX̂̂ToGbWƊ֘At
		v->SetEdge(e);
		e->SetIndex(startnum + i);		// GbW̃CfbNXo^
		e->mom = mesh->Edge.add(e);				// n[tGbWbṼGbWXgɓo^(eꂽ̃AhXێ)
		// ʂo^
		if(!i){
			f = new HEface();					// ʂ1m
			f->SetEdge(e);						// ʂɑn[tGbW1
			f->SetIndex(int(edgecount/vcount)-1);	// ʂ̃CfbNXo^
			f->SetVertNum(vcount);				// ʂ̒_o^
			SetColorStat(&f->Dstat,0.2,0.2,1);	// Fw
			f->mom = mesh->Face.add(f);			// ʂbV̖ʃXgɓo^(fꂽ̃AhXێ)
		}
		e->SetFace(f);							// n[tGbWʂo^
	}

	// n[tGbW̎ւ̃|C^ƁAꂪʂo^
	HEedge *e_ = (HEedge *)mesh->Edge.setSentinel(startnum);		// 1{ڂ̃GbWɊ𗧂Ă
	for(int i=0;i<vcount;i++){
		if(i==vcount-1){
			e_->ne = (HEedge *)mesh->Edge.getSentinelData();		// Ō̃GbWnext͍ŏ̃GbW
		}
		else{
			e_->ne = (HEedge *)mesh->Edge.getDataFromSentinel(i+1);	// GbWXg
			e_ = e_->ne;
		}
	}

}

// OWlMESHɊi[
int VRML_PARSER::GetCoords(FILE *fp,MESH *mesh)
{
	char *p,*q;
	char buf[BUFSIZEMAX],words[BUFSIZEMAX];
	int index=0;	// _̃CfbNX
	Coord c;

	// OWlSēǂݍނ܂1sÂǂݍ
	while(!feof(fp)){
		GetLine(fp,buf);				// 1s擾
		if(strstr(buf,"point") == NULL)	// "point"^OȂ
			continue;					// ܂œǂݑ

		//  "point"^OĂ璸_W擾
		while(GetLine(fp,buf)){							// 1s擾
			if(strchr(buf,']') != NULL) break;			// f[^Ig[N']'̍sǂݍݏI
			HEvert *v = new HEvert();
			p = strtok(buf,",");						// J}؂ŕ𒊏oĂ
			sscanf(p,"%lf %lf %lf",&c.x,&c.y,&c.z);					// f[^i[
			v->SetCod(c);
			v->SetIndex(index);
			v->mom = mesh->Vert.add(v);		// vXgɓo^(vꂽ̃AhXێ)
			//fprintf(stderr,"%p (%lf,%lf,%lf)\n",v,v->cod.x,v->cod.y,v->cod.z);	// debug
			index++;
			while(p != NULL){
				if((p = strtok(NULL,",")) != NULL){
					HEvert *v = new HEvert();
					sscanf(p,"%lf %lf %lf",&v->cod.x,&v->cod.y,&v->cod.z);
					v->index = index;
					v->mom = mesh->Vert.add(v);
					//fprintf(stderr,"%p (%lf,%lf,%lf)\n",v,v->cod.x,v->cod.y,v->cod.z);	// debug
					index++;
				}
			}
		}
		return KOD_TRUE;	// ɓǂݍݏI
	}

	return KOD_ERR;		// OWl擾Ƀt@CI:G[
}

// t@C1s擾AsI[ɕύX
int VRML_PARSER::GetLine(FILE *fp,char buf[])
{
	fgets(buf,BUFSIZEMAX,fp);			// 1s擾
	int len = strlen(buf);				// 1s̒𒲂ׂ
	if(len > 0 && buf[len-1] == '\n')	// Ō̉s\nI[\0ɕύX
		buf[len-1] = '\0';

	return len-1;
}

// ^O
int VRML_PARSER::CheckTags(char buf[])
{
	if(strstr(buf,"AsciiText") != NULL)			return AsciiText;		// 1
	if(strstr(buf,"Cone") != NULL)				return Cone;			// 2
	if(strstr(buf,"Coordinate3") != NULL)		return Coordinate3;		// 3:OW
	if(strstr(buf,"Cube") != NULL)				return Cube;			// 4
	if(strstr(buf,"Cylinder") != NULL)			return Cylinder;		// 5
	if(strstr(buf,"DirectionalLight") != NULL)	return DirectionalLight;// 6
	if(strstr(buf,"FontStyle") != NULL)			return FontStyle;		// 7
	if(strstr(buf,"Group") != NULL)				return Group;			// 8
	if(strstr(buf,"IndexedFaceSet") != NULL)	return IndexedFaceSet;	// 9:t@Zbg_̃CfbNX
	if(strstr(buf,"IndexedLineSet") != NULL)	return IndexedLineSet;	// 10
	if(strstr(buf,"Info") != NULL)				return Info;			// 11
	if(strstr(buf,"LOD") != NULL)				return LOD;				// 12
	if(strstr(buf,"MaterialBinding") != NULL)	return MaterialBinding;	// 14
	if(strstr(buf,"Material") != NULL)			return Material;		// 13
	if(strstr(buf,"MatrixTransform") != NULL)	return MatrixTransform;	// 15
	if(strstr(buf,"NormalBinding") != NULL)		return NormalBinding;	// 17
	if(strstr(buf,"Normal") != NULL)			return Normal;			// 16
	if(strstr(buf,"OrthographicCamera") != NULL)return OrthographicCamera;	// 18
	if(strstr(buf,"PerspectiveCamera") != NULL)	return PerspectiveCamera;	// 19
	if(strstr(buf,"PointLight") != NULL)		return PointLight;		// 20
	if(strstr(buf,"PointSet") != NULL)			return PointSet;		// 21
	if(strstr(buf,"Rotation") != NULL)			return Rotation;		// 22
	if(strstr(buf,"Scale") != NULL)				return Scale;			// 23
	if(strstr(buf,"Separator") != NULL)			return Separator;		// 24
	if(strstr(buf,"ShapeHints") != NULL)		return ShapeHints;		// 25
	if(strstr(buf,"Sphere") != NULL)			return Sphere;			// 26
	if(strstr(buf,"SpotLight") != NULL)			return SpotLight;		// 27
	if(strstr(buf,"Switch") != NULL)			return Switch;			// 28
	if(strstr(buf,"Texture2Transform") != NULL)	return Texture2Transform;	// 30
	if(strstr(buf,"Texture2") != NULL)			return Texture2;		// 29
	if(strstr(buf,"TextureCoordinate2") != NULL)return TextureCoordinate2;	// 31
	if(strstr(buf,"TextureCoordinateBinding") != NULL)	return TextureCoordinateBinding;// 32
	if(strstr(buf,"TransformSeparator") != NULL)		return TransformSeparator;		// 34
	if(strstr(buf,"Transform") != NULL)			return Transform;		// 33
	if(strstr(buf,"Translation") != NULL)		return Translation;		// 35
	if(strstr(buf,"WWWAnchor") != NULL)			return WWWAnchor;		// 36
	if(strstr(buf,"WWWInline") != NULL)			return WWWInline;		// 37

	return KOD_ERR;	// TAGȂ
}